
;*************************************************************************
;* Actually Draws the Screen                                             *
;*************************************************************************

LoadTileMap:
	ld hl, (mappos)													;hl=mappos, de=playerpos, hl=hl+de, tempword1=hl
	ld de, (playerpos)
	add hl, de
	ld de, $1000
	sbc hl, de
	ld (tempword1), hl
	ld a, (mapxhalf)
	ld (xhalf), a
	ld a, 8  																;loop y variable
LTMloop1:
	ld (tempvar1), a
	ld a, 16																;loop x variable
LTMloop2:
	ld (tempvar2), a
	ld a, (xhalf)														;if xhalf=1 then the next tile is in the second half of the byte
	cp 1
	jp z, LTMnextone													
	ld a, 1																	;xhalf=1
	ld (xhalf), a
	ld hl, (tempword1)												;load pointer
	ld a, (hl)															;load byte from map into a
	ld b, %11110000													;and it with %11110000 (gets the higher 4 bits)
	and b
	rrca																		;rotate it into the lower 4 bits
	rrca
	rrca
	rrca
	call LTMdrawit														;we got a, go draw it
	jp LTMnextloop
LTMnextone:
	xor a
	ld (xhalf), a
	ld hl, (tempword1)
	ld a, (hl)
	inc hl
	ld (tempword1), hl
	ld b, %00001111
	and b
	call LTMdrawit
LTMnextloop:
	ld a, (tempvar2)													;decrement a, if it's not 0 then go do the next loop
	dec a
	jp nz, LTMloop2
	ld hl, (curmapwidth)
	ld de, 8
	sbc hl, de
	ex de, hl
	ld hl, (tempword1)
	add hl, de
	ld (tempword1), hl												;load it back into the pointer
	ld a, (mapxhalf)
	ld (xhalf), a
	ld a, (tempvar1)
	dec a
	ret z
	jp LTMloop1

LTMdrawit:
	ld b, a
	ld de, (curmapwidth)
	ld a, e
	ld hl, OutsideMP-2
	cp 64
	jp z, LTMoutside
	ld hl, InsideMP-2											;hl points to OutsideMP-2 (the pointers for each value of a (a=0, goes to grass))
LTMoutside:
	ld a, b
	ld de, 2															;incrementing by words
	ld (tempblock), a
	inc a																;can't very well =0 (djnz would turn it into 255)
	ld b, a																;wanna use djnz
LTMloop3:
	add hl, de														;add
	djnz LTMloop3													;b=b-1, if b<>0 then goto LTMloop3
	call _ldhlind													;hl points to the right pointer, this makes hl point to what that pointer points to 
	ld a, (tempblock)
	cp 9
	call z, characterLTM
	cp $A
	call z, waterLTM
	cp 8
	call z, water2LTM
	ld a, (tempvar1)												;d=y pos
	ld b, a
	ld a, 8
	sub b
	ld d, a
	ld a, (tempvar2)												;e=x pos (based on loop variable)
	ld b, a
	ld a, 16
	sub b
	ld e, a
	push de																;push variables into stack for later use
	ld a, (tempvar1)
	cp 5
	call z, LTMotherstuff
	ld a, (tempvar2)
	cp 8
	call z, LTMotherstuff2
	ld a, (monster1)
	cp 0
	call nz, dungeonblack
	pop de
	jp GridPutSprite									
;*************************************************************************
;* Black Dungeon Background                                              *
;*************************************************************************

dungeonblack:
	ld a, (radiance)
	ld c, a
	ld a, 8
	sub c
	ld b, a
	ld a, (tempvar2)
	cp b
	jr c, makeblack
	ld a, 8
	add a, c
	ld b, a
	ld a, (tempvar2)
	cp b
	jr z, db1
	jr nc, makeblack
db1:
	ld a, 5
	sub c
	ld b, a
	ld a, (tempvar1)
	cp b
	jr c, makeblack
	ld a, 5
	add a, c
	ld b, a
	ld a, (tempvar1)
	cp b
	ret z
	jr nc, makeblack
	ret
makeblack:
	ld hl, blackback
	ret
blackback:
	.db 255, 255, 255, 255, 255, 255, 255, 255
	.db 255, 255, 255, 255, 255, 255, 255, 255
	
;*************************************************************************
;* People Stuff                                                          *
;*************************************************************************

water2LTM:
	ld de, (curmapwidth)
	ld a, e
	cp 64
	ret z
	jr water3LTM
waterLTM:
	ld de, (curmapwidth)
	ld a, e
	cp 64
	ret nz
water3LTM:
	ld a, (walkvar)
	cp 1
	ret nc
	ld de, 16
	add hl, de
	ret
characterLTM:
	push hl
	ld hl, (tempword1)
	ld de, (mappos)
	sbc hl, de
	ld de, $1000
	add hl, de
	ld (cpword), hl
	ld c, 4
	call cplocation
	xor a
	cp b
	jp nz, doorLTM
	ld c, 1
	call cplocation
	ld a, 0
	cp b
	jr z, gobackfromcLTM
	inc hl
	inc hl
	inc hl
	ld a, (hl)
	ld e, a
	inc hl
	ld a, (hl)
	ld d, a
	ld hl, king1
	add hl, de
	ld a, (walkvar)
	cp 1
	call z, dcnextwalk
	pop de
	ret

gobackfromcLTM:
	pop hl
	ret

doorLTM:
	inc hl
	ld a, (hl)
	ld e, a
	inc hl
	ld a, (hl)
	ld d, a
	ld hl, doors
	add hl, de
	ld a, (hl)
	cp 0
	jr z, gobackfromcLTM
	xor a
	ld (tempblock), a
	ld hl, bricks
	pop de
	ret

;*************************************************************************
;* Loads Surrounding Info                                                *
;*************************************************************************

LTMotherstuff2:
	ld a, (tempvar1)
	cp 4
	jp z, loaddown
	cp 6
	jp z, loadup
	ret

LTMotherstuff:
	ld a, (tempvar2)
	cp 8
	jp z, drawchar
	cp 7
	jp z, loadright
	cp 9
	jp z, loadleft
	ret

loadright:
	push hl
	ld a, (tempblock)
	ld (rightblock), a
	ld hl, (leftblockpos)
	inc hl
	ld (rightblockpos), hl
	pop hl
	ret

loadleft:
	push hl
	ld a, (tempblock)
	ld (leftblock), a
	ld a, (xhalf)
	ld (lrblockxhalf), a
	ld hl, (tempword1)
	ld de, (mappos)
	sbc hl, de
	ld de, $1000
	add hl, de
	ld (leftblockpos), hl
	pop hl
	ret

loadup:
	push hl
	ld a, (xhalf)
	ld (udblockxhalf), a
	ld hl, (tempword1)
	ld de, (mappos)
	sbc hl, de
	ld de, $1000
	add hl, de
	ld (upblockpos), hl
	ld a, (tempblock)
	ld (upblock), a
	pop hl
	ret

loaddown:
	push hl
	ld a, (tempblock)
	ld (downblock), a
	ld hl, (tempword1)
	ld de, (mappos)
	sbc hl, de
	ld de, $1000
	add hl, de
	ld (downblockpos), hl
	pop hl
	ret

;*************************************************************************
;* Character Drawing                                                     *
;*************************************************************************

drawchar:
	ld a, (tempblock)
	ld (sameblock), a
	ld hl, (dirword)
	ld a, (walkvar)
	cp 1
	jr c, dcnextwalk
	ret

dcnextwalk:
	push de
	ld de, 16
	add hl, de
	pop de
	ret
