
;*************************************************************************
;* General Selection Menu                                                *
;*************************************************************************

drawselectwindow:
	call waitkey
	call drawstatwindow
	ld bc, $070d
	ld de, $0004
	call makewindow
	ld de, $0344
	ld hl, commandstring
	call drawstring
	ld de, $0a3e
	ld hl, talkstring
	call drawstring
	ld de, $113e
	ld hl, statusstring
	call drawstring
	ld de, $183e
	ld hl, stairsstring
	call drawstring
	ld de, $1f3e
	ld hl, searchstring
	call drawstring
	ld de, $0a5a
	ld hl, spellstring
	call drawstring
	ld de, $115a
	ld hl, itemstring
	call drawstring
	ld de, $185a
	ld hl, doorstring
	call drawstring
	ld de, $1f5a
	ld hl, takestring
	call drawstring
	ld de, $0a3a
	ld (tempvar1), de
	ld de, 0
	ld (tempword3), de
	ld a, 5
	ld (xhalf), a
	xor a
	ld (keyvar), a
dselwindowloop:
	call blinkmenu
	cp 0
	jr nz, dselwindowloop2
	ld b, 60
	call keyloop
	cp 0
	jr nz, dselwindowloop2
	jr dselwindowloop
dselwindowloop2:
	cp 1
	jr z, dseldown
	cp 2
	jr z, dselleft
	cp 3
	jr z, dselright
	cp 4
	jr z, dselup
	cp 6
	jr z, dselect
	ret

dselleft:
	ld a, $3a
	ld (tempvar1), a
	jr dselwindowloop

dselright:
	ld a, $56
	ld (tempvar1), a
	jr dselwindowloop

dseldown:
	ld a, (tempvar2)
	add a, 7
	cp $26
	call z, dseldown2
	ld (tempvar2), a
	jr dselwindowloop

dseldown2:
	ld a, $1f
	ret

dselup:
	ld a, (tempvar2)
	sub 7
	cp $03
	jr z, dselwindowloop
	ld (tempvar2), a
	jr dselwindowloop

dselect:
	ld b, 1
	call keyloop
	cp 0
	jr nz, dselect
	ld a, (tempvar2)
	ld b, a
	ld a, (tempvar1)
	cp $56
	call z, incb
	ld a, b
	cp $0a
	jp z, dselecttalk
	cp $11
	jp z, bigstatwindow
	cp $18
	jp z, gostairs
	cp $1f
	jp z, gosearch
	cp $0b
	jp z, gospell
	cp $12
	jp z, goitem
	cp $19
	jr z, godoor
	cp $20
	jp z, gotake

incb:
	inc b
	ret

;*************************************************************************
;* Door Command                                                          *
;*************************************************************************
godoor:
	call waitkey
	ld a, 5
	call checkitem
	cp 0
	ret z
	ld a, 5
	call dropitem
	ld b, 0
	ld a, (lookdir)
	ld c, 4
	cp 1
	call z, checkdown
	cp 2
	call z, checkleft
	cp 3
	call z, checkright
	cp 4
	call z, checkup
	ld (xhalf), a
	ld (cpword), hl
	call cplocation
	xor a
	cp b
	jr z, nodoorthere
	inc hl
	ld a, (hl)
	ld e, a
	inc hl
	ld a, (hl)
	ld d, a
	ld hl, doors
	add hl, de
	ld a, (hl)
	cp 1
	jr z, nodoorthere
	ld a, 1
	ld (hl), a
	ret

nodoorthere:
	ld hl, $036b
	jp gsearch4

;*************************************************************************
;* Take Command                                                          *
;*************************************************************************
gotake:
	ld c, 2
	ld de, (playerpos)
	ld (cpword), de
	ld a, (mapxhalf)
	ld (xhalf), a
	call cplocation
	ld a, b
	cp 0
	jr z, gtnochest
	inc hl
	ld a, (hl)
	ld d, a
	inc hl
	ld a, (hl)
	ld e, a
	inc hl
	ld a, (hl)
	ld c, a
	inc hl
	ld a, (hl)
	ld b, a
	ld hl, chestinfo
	add hl, bc
	ld a, (hl)
	cp 1
	jr z, gtemptychest
	ld a, d
	push hl
	cp 255
	jr z, gtfoundgold
	cp 24
	jr z, foundesword
	ld e, 1
	call additem
	ld c, d
	pop hl
	cp 0 
	ret z
	push hl
gobacktake:
	push bc
	ld hl, $03bb
	ld (talkword), hl
	call talkit
	pop bc
	ld a, c
	ld de, $3803
	call drawitem
gtnomorechest:
	call pause
	pop hl
	ld a, 1
	ld (hl), a
	ret
gtnochest:
	ld hl, $0381
	jp gsearch4
gtemptychest:
	ld hl, $03e5
	jp gsearch4
gtfoundgold:
	push de
	ld hl, (gold)
	ld d, 0
	add hl, de
	ld (gold), hl
	ld hl, $03fa
	ld (talkword), hl
	call talkit
	pop de
	ld d, 0
	ld l, e
	ld h, 0
	ld bc, $2a50
	call drawnumber
	jr gtnomorechest
foundesword:
	ld (wpn), a
	call updatepower
	ld c, 24
	jr gobacktake

;*************************************************************************
;* Spell Command                                                         *
;*************************************************************************
gospell:
	ld a, (level)
	cp 3
	jp c, gospell2
	ld bc, $080f
	ld de, $0007
	call makewindow
	ld de, $0247
	ld b, 0
	ld hl, spell1
	call addspell
	ld hl, spell2
	call addspell
	ld hl, spell3
	call addspell
	ld hl, spell4
	call addspell
	ld hl, spell5
	call addspell
	ld hl, spell6
	call addspell
	ld hl, spell7
	call addspell
	ld hl, spell8
	call addspell
	ld hl, spell9
	call addspell
	ld hl, spell10
	call addspell
	ld a, (spellnumber)
	ld (menunum), a
	ld de, $0243
	ld (tempvar1), de
	ld de, 0
	ld (tempword3), de
	ld a, 5
	ld (xhalf), a
	xor a
	ld (keyvar), a
spellloop:
	call blinkmenu
	cp 0
	jr nz, spellloop2
	ld b, 60
	call keyloop
	cp 0
	jr nz, spellloop2
	jr spellloop
spellloop2:
	cp 1
	jr z, spelldown
	cp 4
	jr z, spellup
	cp 6
	jr z, spellselect
	jr spellloop

spelldown:
	ld a, (menunum)
	rla
	ld c, a
	rla
	add a, c
	add a, $02
	ld b, a
	ld a, (tempvar2)
	add a, 6
	cp b
	call z, swdown2
	ld (tempvar2), a
	jr spellloop

spellup:
	ld a, (tempvar2)
	sub 6
	jr c, spellloop
	ld (tempvar2), a
	jr spellloop

spellselect:
	ld a, (tempvar2)
	dec a
	dec a
	ld l, a
	ld h, 0
	ld a, 6
	call _divHLbyA
	ld a, l
	cp 0
	jr z, goheal
	cp 8
	jr z, gobigheal
	ld b, a
	ld a, (fighton)
	cp 1
	jp z, fightspells
	ld a, b
	cp 3
	jr z, goradiant
	cp 5
	jp z, gooutside
	cp 6
	jp z, goreturn
	cp 7
	jp z, gorepel
	ret
goheal:
	ld a, (mp)
	cp 4
	ret c
	sub 4
	ld (mp), a
	ld a, r
	and %00000111
	add a, 8
ghsame:
	ld b, a
	ld a, (hp)
	add a, b
	ld b, a
	ld a, (maxhp)
	cp b
	call c, setherb
	ld a, b
	ld (hp), a
	ret

gobigheal:
	ld a, (mp)
	cp 10
	ret c
	sub 10
	ld (mp), a
	ld a, r
	and %00001111
	add a, 30
	jr ghsame
goradiant:
	ld a, (mp)
	cp 3
	ret c
	sub 3
	ld (mp), a
	ld a, 3
	ld (radiance), a
	ld a, 100
	ld (radcounter), a
	ret
gooutside:
	ld a, (mp)
	cp 6
	ret c
	sub 6
	ld (mp), a
	ld hl, (curmap)
	ld a, l
	cp 0
	ret z
	ld hl, (worldpos)
	ld (playerpos), hl
	ld a, (wxhalf)
	ld (mapxhalf), a
	ld hl, 0
	ld (curmap), hl
	jp LoadMap
goreturn:
	ld a, (mp)
	cp 8
	ret c
	sub 8
	ld (mp), a
	ld hl, 6931
	ld (playerpos), hl
	ld a, 0
	ld (mapxhalf), a
	ld hl, 0
	ld (curmap), hl
	jp LoadMap
gorepel:
	ld hl, (curmap)
	ld a, h
	cp 0
	ret nz
	ld a, (mp)
	cp 2
	ret c
	sub 2
	ld (mp), a
	ld a, 60
	ld (repelcounter), a
	ret

addspell:
	inc b
	ld a, (spellnumber)
	cp b
	jr c, asskip
	push bc
	push hl
	push de
	call drawstring
	pop de
	pop hl
	pop bc
asskip:
	ld a, d
	add a, 6
	ld d, a
	ret
	
gospell2:
	ld a, (fighton)
	cp 1
	ret z
	ld hl, $0326
	jr gsearch4

;*************************************************************************
;* Search Command                                                        *
;*************************************************************************
gosearch:
	ld hl, (playerpos)
	ld de, 4269
	call hlde
	cp 2
	jr z, findarmor
	ld de, 11428
	call hlde
	cp 2
	jr z, findtoken
	ld de, 4194
	call hlde
	cp 2
	jr z, findflute
	ld hl, $02d1
	ld (talkword), hl
	call talkit
	call pause
	ld a, (curmapwidth)
	cp 64
	jr z, gsearch2
	ld a, (sameblock)
	cp 5
	jr z, gsearch3
gsearch2:
	ld hl, $02f4
gsearch4:
	ld (talkword), hl
	call talkit
	jp pause
gsearch3:
	ld hl, $030d
	jr gsearch4
findarmor:
	ld hl, $23e1
	call gsearch4
	ld a, 31
	ld (armor), a
	jp updatepower
findtoken:
	ld a, 16
	call checkitem
	cp 0
	jr nz, gsearch2
	ld d, 16
	call additem
	ld hl, $2404
	jp gsearch4
findflute:
	ld a, 9
	call checkitem
	cp 0
	jr nz, gsearch2
	ld d, 9
	call additem
	ld hl, $2426
	jp gsearch4

;*************************************************************************
;* Stairs Command                                                        *
;*************************************************************************
gostairs:
	ld c, 5
	call checktransport
	cp 0
	ret nz
	ld hl, $02b5
	jr gsearch4

;*************************************************************************
;* Big Status Window                                                     *
;*************************************************************************
bigstatwindow:
	call waitkey
	ld bc, $050f
	ld de, $0007
	call makewindow
	ld hl, namestring
	ld de, $0233
	call drawstring
	ld hl, strengthstring
	ld de, $084e
	call drawstring
	ld hl, agilitystring
	ld de, $0e57
	call drawstring
	ld hl, mhpstring
	ld de, $1447
	call drawstring
	ld hl, mmpstring
	ld de, $1a45
	call drawstring
	ld hl, apowerstring
	ld de, $2040
	call drawstring
	ld hl, dpowerstring
	ld de, $263c
	call drawstring
	ld hl, weaponstring
	ld de, $2c2b
	call drawstring
	ld hl, armorstring
	ld de, $3230
	call drawstring
	ld hl, shieldstring
	ld de, $3830
	call drawstring
	ld hl, name
	ld de, $0248
	call drawstring
	ld hl, (strength)
	ld bc, $086a
	call drawnumber
	ld hl, (agility)
	ld bc, $0e6a
	call drawnumber
	ld hl, (maxhp)
	ld bc, $146a
	call drawnumber
	ld hl, (maxmp)
	ld bc, $1a6a
	call drawnumber
	ld hl, (attackpower)
	ld bc, $206a
	call drawnumber
	ld hl, (defensepower)
	ld bc, $266a
	call drawnumber
	ld a, (wpn)
	ld de, $2c48
	call drawitem
	ld a, (armor)
	ld de, $3248
	call drawitem
	ld a, (shield)
	ld de, $3848
	call drawitem
	jp pause
;*************************************************************************
;* Item Routine                                                          *
;*************************************************************************
goitem:
	call waitkey
	ld bc, $080f
	ld de, $0007
	call makewindow
	ld hl, items
	ld de, $0247
	ld b, 10
gitm2:
	ld a, (hl)
	push de
	push bc
	push hl
	call drawitem
	pop hl
	pop bc
	pop de
	ld a, d
	add a, 6
	ld d, a
	inc hl
	inc hl
	djnz gitm2
	ld de, $0243
	ld (tempvar1), de
	ld de, 0
	ld (tempword3), de
	ld a, 5
	ld (xhalf), a
	xor a
	ld (keyvar), a
giloop:
	call blinkmenu
	cp 0
	jr nz, giloop2
	ld b, 60
	call keyloop
	cp 0
	jr nz, giloop2
	jr giloop
giloop2:
	cp 1
	jr z, gidown
	cp 4
	jr z, giup
	cp 6
	jr z, giselect
	jr giloop

gidown:
	ld a, (tempvar2)
	add a, 6
	cp $3e
	jr z, giloop
	ld (tempvar2), a
	jr giloop

giup:
	ld a, (tempvar2)
	sub 6
	call c, giup2
	ld (tempvar2), a
	jr giloop

giup2:
	ld a, $02
	ret

giselect:
	ld a, (tempvar2)
	sub 2
	ld l, a
	ld h, 0
	ld a, 6
	call _divHLbyA
	ld de, items
	add hl, hl
	add hl, de
	ld a, (hl)
	cp 2
	jr z, gotorch
	cp 10
	jr z, gotablet
	cp 1
	jr z, goherb
	cp 4
	jr z, gowings
	cp 17
	jr z, gorainbow
	cp 15
	jr z, gogwaelin
	cp 5
	jp z, godoor
	cp 6
	jp z, gofighterring
	cp 3
	jp z, godragonscale
	ret

gowings:
	call dropitem
	ld hl, 0
	ld (curmap), hl
	ld hl, 6931
	ld (playerpos), hl
	xor a
	ld (mapxhalf), a
	jp LoadMap
gotorch:
	call dropitem
	ld a, 1
	ld (radiance), a
	ld a, 150
	ld (radcounter), a
	ret

gotablet:
	call dropitem
	ld hl, $1139
	jp gsearch4

goherb:
	call dropitem
	ld a, r
	and %00000111
	add a, 14
	ld b, a
	ld a, (hp)
	add a, b
	ld b, a
	ld a, (maxhp)
	cp b
	call c, setherb
	ld a, b
	ld (hp), a
	ret
setherb:
	ld b, a
	ret

gorainbow:
	ld hl, (playerpos)
	ld de, 7326
	call hlde
	cp 2
	jr nz, otherrain
	dec hl
	ld (playerpos), hl
	ret
otherrain:
	ld de, 7325
	call hlde
	cp 2
	ret nz
	inc hl
	ld (playerpos), hl
	ret

gogwaelin:
	ld hl, $25de
	ld (talkword), hl
	call talkit
	ld hl, (nextlevel)
	ld bc, $3160
	call drawnumber
	jp pause

gofighterring:
	ld a, (defensepower)
	push af
	call updatepower
	pop af
	ld (defensepower), a
	ld a, (attackpower)
	ld a, 5
	ld (attackpower), a
	ret

godragonscale:
	ld a, (attackpower)
	push af
	call updatepower
	pop af
	ld (attackpower), a
	ld a, (defensepower)
	inc a
	inc a
	ld (defensepower), a
	ret
;*************************************************************************
;* Talking Routines                                                      *
;*************************************************************************

dselecttalk:
	call waitkey
	ld b, 0
	ld a, (lookdir)
	ld c, 1
	cp 1
	call z, checkdown
	cp 2
	call z, checkleft
	cp 3
	call z, checkright
	cp 4
	call z, checkup
	ld (xhalf), a
	ld (cpword), hl
	call cplocation
	xor a
	cp b
	jr z, noonethere
	inc hl
	ld a, (hl)
	ld e, a
	inc hl
	ld a, (hl)
	ld d, a
	ld (talkword), de
dselect2:
	call talkit
	jp pause

noonethere:
	ld de, $0000
	ld (talkword), de
	jr dselect2

checkup:
	ld hl, (upblockpos)
	ld a, (udblockxhalf)
	ret

checkdown:
	ld hl, (downblockpos)
	ld a, (udblockxhalf)
	ret

checkright:	
	ld hl, (rightblockpos)
	ld a, (lrblockxhalf)
	ret

checkleft:	
	ld hl, (leftblockpos)
	ld a, (lrblockxhalf)
	ret

decde:
	dec de
	ret

talkit:
	ld hl, dwtalk
	call loadstring
	ld de, (talkword)
	ld a, d
	cp 255
	jp z, specialtalk
	add hl, de
	push hl
	ld bc, $000f
	ld de, $0507
	call makewindow
	pop hl
	ld de, $2a03
	ld (tempword1), de
	ld a, 1
	ld (scrollcounter), a
	call drawtalk
	jp LoadMap

drawtalk:
	ld a, (hl)
	cp 255
	ret z
	cp 0
	call z, nextline
	ld (tempvar1), a
	push hl
	ld hl, tempvar1
	ld de, (tempword1)
	call drawletter
	ld de, (_penCol)
	ld (tempword1), de
	ld a, (keyvar)
	ld b, 15
	cp 6
	call nz, keyloop
	pop hl
	inc hl
	jr drawtalk

nextline:
	ld b, a
	ld a, (tempword1+1)
	add a, 7
	ld (tempword1+1), a
	cp 63
	call z, scrollupnextline
	ld a , 3
	ld (tempword1), a
	ld a, b
	ret

scrollupnextline:
	push hl
	ld a, (scrollcounter)
	dec a
	jr nz, sunlback
	call pause
	ld a, 3
sunlback:
	ld (scrollcounter), a
	ld b, 7
sunl4:
	ld hl, $fea0
	ld de, $fe90
	push bc
	ld b, 21
sunl3:
	push bc
	ld b, 16
sunl2:
	ld a, (hl)
	ld (de), a
	inc de
	inc hl
	djnz sunl2
	pop bc
	djnz sunl3
	ld b, 3
	call keyloop
	pop bc
	djnz sunl4
	ld a, 56
	ld (tempword1+1), a
	pop hl
	ret
scrollcounter:
	.db 1

;*************************************************************************
;* Special Talk (Shops, King, etc.)                                      *
;*************************************************************************

specialtalk:
	push de
	ld a, e
	cp 5
	jp c, weaponarmorshop
	cp 10
	jp c, itemshop
	cp 15
	jp c, innshop
	cp 17
	jp c, keyshop
	cp $13
	jp z, wizarddude
	cp $12
	jp z, dragonlordtalk
	cp $11
	jp z, kingtalk
	cp $14
	jp z, princesstalk
	cp $15
	jp z, nshrineguy

sshrineguy:
	pop de
	ld a, 12
	call checkitem
	cp 0
	jr z, nothreeitems
	ld a, 13
	call checkitem
	cp 0
	jr z, nothreeitems
	ld a, 16
	call checkitem
	cp 0
	jr z, nothreeitems
	ld a, 12
	call dropitem
	ld a, 13
	call dropitem
	ld d, 17
	call additem
	ld hl, $2550
	jp gsearch4
nothreeitems:
	ld hl, $24e3
	jp gsearch4

nshrineguy:
	pop de
	ld a, 14
	call checkitem
	cp 0
	jr z, nosilverharp
	ld hl, $249e
	call gsearch4
	ld a, 14
	call dropitem
	ld d, 12
	jp additem
nosilverharp:
	ld hl, $2448
	jp gsearch4

princesstalk:
	pop de
	ld a, 15
	call checkitem
	cp 0
	jr nz, talkpr2
	ld hl, $2336
	call gsearch4
	ld d, 15
	jp additem
talkpr2:
	ld hl, $23a3
	jp gsearch4

kingtalk:
	pop de
	ld a, 11
	call checkitem
	cp 0
	jr nz, endgame
	ld a, (doors+2)
	cp 0
	jr z, kingtalk2
	call gogwaelin
	ld hl, $13a6
	call gsearch4
	call yesnowind
	cp 1
	jr z, kingtalk3
	ld hl, dwsave
	inc hl
	inc hl
	ld (findfile), hl
	dec hl
	dec hl
	rst 20h
	rst 10h
	jp c, nofile
	ld a,b
	ex de,hl
	call _ahl_plus_2_pg3
	call _set_abs_dest_addr
	ld a,0
	ld hl, name
	call _set_abs_src_addr
	xor a
	ld hl, 99
	call _set_mm_num_bytes
	call _mm_ldir
	ld hl, $140d
	call gsearch4
kingtalk3:
	ld hl, $1373
	jp gsearch4
kingtalk2:
	ld hl, $0eb8
	jp gsearch4
endgame:
	ld hl, $207c
	call gsearch4
	call CloseGrey
	call ClearScreen
	pop hl
	pop hl
	pop hl
	ret

dragonlordtalk:
	pop de
	ld a, 11
	call checkitem
	pop hl
	cp 0
	ret nz
	push hl
	ld hl, $1f76
	call gsearch4
	ld hl, dwfight
	call loadstring
	ld a, 1
	ld (fighton), a
	ld a, 37
	pop hl
	ld (dragword), hl
	call startfight
	ld hl, (dragword)
	push hl
	xor a
	ld (fighton), a
	call loadmap
	ld d, 11
	jp additem
dragword:
	.dw 0
wizarddude:
	ld hl, $10e7
	call gsearch4
	ld b, 20
	call flicker
	ld hl, (maxmp)
	ld (mp), hl
	pop de
	pop hl
	ret

keyshop:
	ld hl, $1b56
	ld (talkword), hl
	call talkit
	pop de
	ld a, e
	cp $10
	call z, keyrimuldar
	cp $0f
	call z, keytantegel
	ld l, a
	ld h, 0
	push hl
	ld bc, $3820
	call drawnumber
	call yesnowind
	cp 0
	jr z, buykey
	pop hl
	ret
buykey:
	pop hl
	push hl
	ld de, (gold)
	call hlde
	cp 1
	jp z, nomoneyshop
	ld e, 1
	ld d, 5
	call additem
	pop hl
	ld de, (gold)
	ex de, hl
	sub 0
	sbc hl, de
	ld (gold), hl
	ret
keyrimuldar:
	ld a, 53
	ret
keytantegel:
	ld a, 85
	ret

innshop:
	ld hl, $1022
	ld (talkword), hl
	call talkit
	pop de
	ld a, e
	cp $0a
	call z, innbrecconary
	cp $0b
	call z, inngarinham
	cp $0c
	call z, innkol
	cp $0d
	call z, innrimuldar
	cp $0e
	call z, inncantlin
	ld l, a
	ld h, 0
	push hl
	ld bc, $3137
	call drawnumber
	call yesnowind
	cp 0
	jr z, gosleepininn
	pop hl
	ld hl, $1072
	ld (talkword), hl
	jp talkit
gosleepininn:
	pop hl
	ld de, (gold)
	call hlde
	cp 1
	jp z, nomoneyshop
	push hl
	ld hl, $108b
	call gsearch4
	ld a, ($C008)
	ld b, a 											;fade out
	ld a, 31
	sub b
	ld b, a
	push bc
innloop1:
	push bc
	ld b, 5
	call keyloop
	pop bc
	call contrastup
	djnz innloop1
	ld b, 120
	call keyloop
	pop bc
	pop hl
	push bc
	ld de, (gold)
	ex de, hl
	sub 0
	sbc hl, de
	ld (gold), hl
	ld hl, (maxmp)
	ld (mp), hl
	ld hl, (maxhp)
	ld (hp), hl
	call drawstatwindow
	pop bc												;fade back in
innloop2:
	push bc
	ld b, 5
	call keyloop
	pop bc
	call contrastdown
	djnz innloop2
	ld hl, $1099
	ld (talkword), hl
	jp talkit
	
innbrecconary:
	ld a, 6
	ret
inngarinham:
	ld a, 25
	ret
innkol:
	ld a, 20
	ret
innrimuldar:
	ld a, 55
	ret
inncantlin:
	ld a, 100
	ret

itemshop:
	ld hl, $0f49
	ld (talkword), hl
	call talkit
	pop de
	call shopwindow
	ld e, a
	ld d, 0
	add hl, de
	ld a, (hl)
	push af
	call findsellcost
	add hl, hl
	ld de, (gold)
	call hlde
	cp 1
	jp z, nomoneyshop
	pop af
	push af
	ld e, 1
	ld d, a
	call additem
	cp 0
	jr z, noroomtobuy
	pop af
	push af
	call findsellcost
	add hl, hl
	ld de, (gold)
	sub 0
	ex de, hl
	sbc hl, de
	ld (gold), hl
noroomtobuy:
	pop af
	ld hl, $0fe5
	jp gsearch4

weaponarmorshop:
	ld hl, $0f0b
	ld (talkword), hl
	call talkit
	pop de
	call shopwindow
	ld e, a
	ld d, 0
	add hl, de
	ld a, (hl)
	push af
	call findsellcost
	add hl, hl
	ld de, (gold)
	call hlde
	cp 1
	jp z, nomoneyshop
	pop af
	push af
	cp 25
	jr c, buybackwpn
	cp 32
	jr c, buybackarm
	ld a, (shield)
	jr donewithshop
buybackwpn:
	ld a, (wpn)
	jr donewithshop
buybackarm:
	ld a, (armor)
donewithshop:
	ld (menunum), a
	cp 0
	jr z, skipbuyback
	ld hl, $0f7e
	ld (talkword), hl
	call talkit
	ld a, (menunum)
	ld de, $2a41
	call drawitem
	ld a, (menunum)
	call findsellcost
	ld bc, $310f
	push hl
	call drawnumber
	pop hl
	ld de, (gold)
	add hl, de
	ld (gold), hl
skipbuyback:
	pop af
	push af
	call findsellcost
	add hl, hl
	ld de, (gold)
	ex de, hl
	sub 0
	sbc hl, de
	ld (gold), hl
	pop af
	cp 25
	jr c, buywpn
	cp 32
	jr c, buyarm
	ld (shield), a
doneagian:
	call pause
	call updatepower
	ld hl, $0faa
	jp gsearch4
buywpn:
	ld (wpn), a
	jr doneagian
buyarm:
	ld (armor), a
	jr doneagian
findsellcost:
	ld l, a
	ld h, 0
	add hl, hl
	add hl, hl
	ld de, iteminfo
	add hl, de
	inc hl
	inc hl
	ld a, (hl)
	ld e, a
	inc hl
	ld a, (hl)
	ld d, a
	ex de, hl
	ld a, (hl)
	ld e, a
	inc hl
	ld a, (hl)
	ld d, a
	ex de, hl
	ret
nomoneyshop:
	pop af	
	ld hl, $0fc0
	jp gsearch4

shopwindow:
	push de
	ld bc, $070f
	ld de, $0004
	call makewindow
	pop de
	ld hl, shopstart
	ld a, e
	sub 0
	rla
	ld b, a
	rla
	add a, b
	ld e, a
	ld d, 0
	add hl, de
	push hl
	ld b, 6
	ld de, $023f
shopwloop:
	ld a, (hl)
	cp 0
	jr z, swloopdone
	push hl
	push de
	push bc
	ld l, a
	ld h, 0
	add hl, hl
	add hl, hl
	ld de, iteminfo
	add hl, de
	inc hl
	inc hl
	ld a, (hl)
	ld e, a
	inc hl
	ld a, (hl)
	ld d, a
	ex de, hl
	ld a, (hl)
	ld e, a
	inc hl
	ld a, (hl)
	ld d, a
	ex de, hl
	add hl, hl
	pop de
	pop bc
	push bc
	push de
	ld c, $6a
	call drawnumber
	pop bc
	pop de
	pop hl
	ld a, (hl)
	push hl
	push de
	push bc
	call drawitem
	pop bc
	pop de
	ld a, 6
	add a, d
	ld d, a
	pop hl
	inc hl
	djnz shopwloop
swloopdone:
	ld a, 6
	sub b
	ld (menunum), a
	ld de, $023b
	ld (tempvar1), de
	ld de, 0
	ld (tempword3), de
	ld a, 5
	ld (xhalf), a
	xor a
	ld (keyvar), a
swsloop:
	call blinkmenu
	cp 0
	jr nz, swsloop2
	ld b, 60
	call keyloop
	ld a, (keyvar)
	cp 0
	jr nz, swsloop2
	jr swsloop
swsloop2:
	cp 1
	jr z, swdown
	cp 4
	jr z, swup
	cp 6
	jr z, swsselect
	cp 9
	jr z, swsback
	jp swsloop

swsback:
	pop hl
	pop hl
	pop hl
	ret

swdown:
	ld b, $02
	ld a, (menunum)
	rla
	ld c, a
	rla
	add a, c
	add a, b
	ld b, a
	ld a, (tempvar2)
	add a, 6
	cp b
	call z, swdown2
	ld (tempvar2), a
	jp swsloop

swdown2:
	ld b, 6
	sub b
	ret

swup:
	ld a, (tempvar2)
	sub 6
	jp c, swsloop
	ld (tempvar2), a
	jp swsloop

swsselect:
	pop hl
	ld b, 0
	ld a, (tempvar2)
	cp 3
	call nc, ae0
	cp 9
	call nc, ae0
	cp 15
	call nc, ae0
	cp 21
	call nc, ae0
	cp 27
	call nc, ae0
	ld a, b
	ret
ae0:
	inc b
	ret

menunum:
	.db 0
