
;*************************************************************************
;* Subroutines                                                           *
;*************************************************************************


checkitem:
	push af
	call dropitem
	cp 0
	jr z, noitem
	pop de
	call additem
	ld a, 1
	ret
noitem
	pop af
	xor a
	ret

blinkmenu:
	ld de, (tempvar1)
	ld hl, xhalf
	call drawletter
	ld b, 60	
	call keyloop
	ld de, (tempvar1)
	ld hl, ABCstring+26
	call drawstring
	ld a, (keyvar)
	ret

updatepower:
	ld a, (wpn)
	call getitemvalue
	ld b, a
	ld a, (strength)
	add a, b
	ld (attackpower), a
	ld a, (armor)
	call getitemvalue
	ld c, a
	ld a, (shield)
	call getitemvalue
	ld b, a
	ld a, (agility)
	push bc
	ld l, a
	ld h, 0
	ld a, 2
	call _divHLbyA
	pop bc
	ld a, l
	add a, b
	add a, c
	ld (defensepower), a
	ret
getitemvalue:
	ld l, a
	ld h, 0
	add hl, hl
	add hl, hl
	ld de, iteminfo
	add hl, de
	inc hl
	inc hl
	ld a, (hl)
	ld e, a
	inc hl
	ld a, (hl)
	ld d, a
	ex de, hl
	inc hl
	inc hl
	ld a, (hl)
	ret
	
loadstring:
	inc hl
	inc hl
	ld (findfile), hl
	dec hl
	dec hl
	rst 20h
	rst 10h
	jp c, nofile
	ld a,b
	ex de,hl
	call _ahl_plus_2_pg3
	call _set_abs_src_addr
	ld a,1
	ld hl,$0100
	call _set_abs_dest_addr
	xor a
	ld hl,$2E40
	call _set_mm_num_bytes
	call _mm_ldir
	call _ram_page_1
	ld hl, $8100
	ret

flicker:
	push bc
	call contrastup
	call contrastup
	ld b, 5
	call keyloop
	call contrastdown
	call contrastdown
	ld b, 5
	call keyloop
	pop bc
	djnz flicker
	ret

yesnowind:
	ld bc, $0709
	ld de, $0002
	call makewindow
	ld de, $0540
	ld hl, yesstring
	call drawstring
	ld de, $0d40
	ld hl, nostring
	call drawstring
	ld de, $053b
	ld (tempvar1), de
	ld a, 5
	ld (xhalf), a
	xor a
	ld (keyvar), a
ynloop:
	call blinkmenu
	cp 0
	jr nz, ynwindowloop2
	ld b, 60
	call keyloop
	ld a, (keyvar)
	cp 0
	jr nz, ynwindowloop2
	jr ynloop
ynwindowloop2:
	cp 1
	jr z, yndown
	cp 4
	jr z, ynup
	cp 6
	jr z, yndone
	jr ynloop
yndown:
	ld a, $0d
	ld (tempvar2), a
	jp ynloop
ynup:
	ld a, $05
	ld (tempvar2), a
	jp ynloop
yndone:
	ld a, (tempvar2)
	cp $0d
	jr z, ynyes
	xor a
	ret
ynyes:
	ld a, 1
	ret
nostring:
	.db "NO", 0
yesstring:
	.db "YES", 0

hlde:
	ld a, h
	ld b, d
	cp b
	jr z, nexthlde
	jr nc, biggerhl
	xor a
	ret
nexthlde
	ld a, l
	ld b, e
	cp b
	jr z, samehl
	jr nc, biggerhl
	xor a
	ret
biggerhl:
	ld a, 1
	ret
samehl:
	ld a, 2
	ret

additem:
	ld hl, items
	ld b, 10
ailoop1:
	ld a, (hl)
	cp 0
	jr z, aiemptyspace
	inc hl
	inc hl
	djnz ailoop1
	ld hl, $039f
	ld (talkword), hl
	call talkit
	call pause
	xor a
	ret

dropitem:
	ld c, a
	ld hl, items
	ld b, 10
diloop1:
	ld a, (hl)
	cp c
	jr z, difoundit
	inc hl
	inc hl
	djnz diloop1
	xor a
	ret
difoundit
	xor a
	ld (hl), a
	ld a, c
	ret

aiemptyspace:
	ld a, d
	ld (hl), a
	inc hl
	ld a, (hl)
	inc a
	ld (hl), a
	dec hl
	ret

nofile:
	call CloseGrey
	ld hl, (findfile)
	ld de, $1c20
	call drawstring
	ld hl, nofilestring
	ld de, $2320
	call drawstring
	call pause
	jp _jforcecmdnochar

ClearScreen:
    ld hl,$fc00               
    ld (hl),l
    ld de,$fc01
    ld bc,1023
    ldir
    ld hl,$fc00              
    ld de,$ca00
    ld bc,1023
    ldir
    ret

pause:
	call waitkey
pause3:
	ld a, %00111111
	out (1), a
	nop
	nop
	in a, (1)
	and %00100000
	jr z, pause2
	jr pause3

pause2:													;waits untils 2nd key is let go
	jp waitkey

keyloop:
	xor a												;most of games processing goes here, because it doubles as a null loop
	ld (keyvar), a
	ld (keycounter), a

keyloopb:
	ld c, b
	ld b, 50
keyloop2:
 	ld a,%1111110
	out (1),a
 	nop
 	in a,(1)
	ld e, 1
 	rra
 	call nc,ldkey
	inc e
 	rra
 	call nc,ldkey
	inc e
 	rra
 	call nc,ldkey
	inc e
 	rra
 	call nc,ldkey
	inc e
	ld a,%00111111
	out (1), a
	nop
	in a, (1)
	and %01000000
	call z, ldkey
	inc e
	in a, (1)
	and %00100000
	call z, ldkey
	inc e
	ld a,%01111101
	out (1), a
	nop
	in a, (1)
	ld l, a
	and %00000010
	call z, ldkey
	inc e
	ld a, l
	and %00000100
	call z, ldkey
	inc e
	ld a,%01011111
	out (1), a
	nop
	in a,(1)
	and %10000000
	call z, ldkey
	djnz keyloop2
	ld b, c
	djnz keyloopb
	ld a, (keyvar)
	ret

ldkey:
	ld d, a
	ld a, e
	ld (keyvar), a
	ld a, (keycounter)
	cp 30
	jr z, staykey
	inc a
	ld (keycounter), a
	ld a, 0
	ld (keyvar), a
staykey:
	ld a, d
	ret
; keys:
; 1=down
; 2=left
; 3=right
; 4=up
; 5=exit
; 6=2nd
; 7=plus
; 8=minus
; 9=alpha
keycounter:
	.db 0

makewindow:														;rather important
; b=left
; c=right
; d=bottom
; e=top
	ld (tempword3), bc
	ld (tempword2), de
	ld hl, upperleftcorner				;draw corners
	ld e, b
	call GridPutSprite
	call getdimback							;load registers back with window dimensions
	ld hl, upperrightcorner
	ld e, c
	call GridPutSprite
	call getdimback
	ld hl, lowerrightcorner
	ld d, e
	ld e, c
	call GridPutSprite
	call getdimback
	ld hl, lowerleftcorner
	ld d, e
	ld e, b
	call GridPutSprite
	call getdimback
	ld a, c
	sub b
	cp 1
	jr z, skiptb
	ld a, b
toploop:											;draw top and bottom of window
	inc a
	ld (tempvar1), a
	ld hl, upborder
	ld e, a
	call GridPutSprite
	call getdimback
	ld a, (tempvar1)
	ld hl, downborder
	ld d, e
	ld e, a
	call GridPutSprite
	call getdimback
	dec c
	ld a, (tempvar1)
	cp c
	jr nz, toploop
skiptb:
	call getdimback							;draw left and right of window
	ld a, e
	sub d
	cp 1
	ret z
	ld a, d
leftloop:
	inc a
	ld (tempvar1), a
	ld hl, leftborder
	ld e, b
	ld d, a
	call GridPutSprite
	call getdimback
	ld a, (tempvar1)
	ld hl, rightborder
	ld e, c
	ld d, a
	call GridPutSprite
	call getdimback
	dec e
	ld a, (tempvar1)
	cp e
	jr nz, leftloop
	call getdimback							;fill window
	ld a, b
	inc a
fillloop1:
	ld (tempvar1), a
	call getdimback
	ld a, e
	sub d
	cp 1
	ret z
	ld a, c
	sub b
	cp 1
	ret z
	ld a, d
fillloop2:
	inc a
	ld (tempvar2), a
	ld hl, emptysprite
	ld d, a
	ld a, (tempvar1)
	ld e, a
	call GridPutSprite
	call getdimback
	dec e
	ld a, (tempvar2)
	cp e
	jr nz, fillloop2
	call getdimback
	ld a, (tempvar1)
	inc a
	cp c
	jr nz, fillloop1
	ret

getdimback:
	ld bc, (tempword3)
	ld de, (tempword2)
	ret

drawitem:
	push de
	ld l, a
	ld h, 0
	add hl, hl
	add hl, hl
	ld de, iteminfo
	add hl, de
	ld a, (hl)
	ld e, a
	inc hl
	ld a, (hl)
	ld d, a
	ex de, hl
	pop de
	jp drawstring
	
drawstring:														;simple memory solutions
	ld (_penCol), de
	jp _vputs

drawletter:
	ld (_penCol), de
	ld b, 1
	jp _vputsn

; The following was borrowed (and modified to display 'cleaner' numbers) from Jezzball
; thx to Magnus Svedin :)
freakynumber2:
	ld a, l
	cp 232 
	jr nc, drawnumber2
	ld a, c
	add a, 4
	ld c, a
	dec d
	jr drawnumber2

freakynumber:
	ld a, l
	cp $10
	jr nc, drawnumber2
	ld a, c
	add a, 4
	ld c, a
	dec d
	jr drawnumber2

drawnumber:
	ld d, 5									;5 digits
	ld a, h	
	cp 39									;if number is between 9984 and 10240, call special routine
	jr z, freakynumber
	jr nc, drawnumber2
	dec d									;4 digits
	ld a, c
	add a, 4								;add 4 to starting coordinates of number (one digit less)
	ld c, a
	ld a, h
	cp 3									;if number is between 768 and 1024, call special routine
	jr z, freakynumber2
	jr nc, drawnumber2
	ld a, c
	add a, 4
	ld c, a
	ld a, l
	dec d									;3 digits
	cp 100
	jr nc, drawnumber2
	ld a, h									;if number is between 256 and 768, it is 3 digits
	cp 0
	jr nz, drawnumber2
	ld a, c
	add a, 4
	ld c, a
	ld a, l
	dec d									;2 digits
	cp 10 
	jr nc, drawnumber2
	ld a, c
	add a, 4
	ld c, a
	dec d									;1 digit
	
drawnumber2:
	ld (_penCol), bc
	ld b, d								;number of digits
	push de
	ld de, numberbuffer+4   ;buffer to store ASCII in
PNStl1:
  call _divHLby10   ;call function to convert from number to digit
  add a, '0'          ;convert digit to ASCII-number for digit
  ld (de), a          ;store in ASCII-buffer
  dec de
  djnz PNStl1         ;loop 5 times
  ld hl, numberbuffer
	pop de
	ld b, d
	ld a, 5
	sub b
	ld d, 0
	ld e, a
	add hl, de
  jp _vputsn   	;print it to screen

; compares locations for characters, chests, doors, etc.
; c=type to check for
; cpword=location to check for
; b=0 if nothing
cplocation:
	ld hl, (mapsize)
	ld de, (mappos)
	add hl, de
	ld a, (hl)
	ld b, a
	inc hl
cplloop:
	push hl
	ld de, (cpword)
	call _ldhlind
	ld a, d
	cp h
	jr nz, cpl4
	ld a, e
	cp l
	jp z, cpl2
cpl4:
	pop hl
	ld de, 8
	add hl, de
	djnz cplloop
	ret

cpl2:
	pop hl
	inc hl
	inc hl
	ld a, (xhalf)
	rrc a
	ld b, a
	ld a, c
	add a, b
	ld b, a
	ld a, (hl)
	cp b
	jr nz, cpl3
	ret

cpl3:
	ld b, 0
	ret

;generally quick and easy routines :)

contrastup:
	ld a, ($C008)
	inc a
	ld ($C008), a
	out (2), a
	ret

contrastdown:
	ld a, ($c008)
	dec a
	ld ($C008), a
	out (2), a
	ret

;Used this to find values for debuging (its slower to use the debuger in VTI)
debugdisp:
	ld bc, $3030
	call drawnumber
	jp pause

waitkey:
	ld b, 1
	call keyloop
	cp 0
	jr nz, waitkey
	ret

